import java.io.IOException ;

public class Test {
	
	public static void main(String[] args) throws IOException {
		String addr = args[0] ;
		Server s = new Server(addr) ;
		Client c = new Client(addr) ;
		new Thread(s).start() ;
		c.run() ;
	}
	
	public static String readLine(UnixSocket sock) throws IOException {
		byte[] buf = new byte[100] ;
		StringBuffer sb = new StringBuffer() ;
		while ((sb.length() == 0) || (sb.charAt(sb.length() - 1) != '\n')) {
			int n = sock.read(buf) ;
			for (int i = 0 ; i < n ; ++i) sb.append((char)(buf[i] & 0xff)) ;
		}
		return sb.toString() ;
	}
	
}

class Client implements Runnable {
	
	private String addr ;
	
	public Client(String addr) {
		this.addr = addr ;
	}
	
	public void run() {
		try {
			Thread.sleep(250) ;
			UnixSocket sock = new UnixSocket(addr) ;
			sock.write("hello world\n".getBytes()) ;
			String response = Test.readLine(sock) ;
			System.err.println("client: got response: " + response) ;
			sock.close() ;
		}
		catch (IOException e) {
			throw new RuntimeException(e) ;
		}
		catch (InterruptedException e) {
			throw new RuntimeException(e) ;
		}
	}
	
}

class Server implements Runnable {
	
	private String addr ;
	
	public Server(String addr) {
		this.addr = addr ;
	}
	
	public void run() {
		try {
			UnixServerSocket ssock = new UnixServerSocket(addr) ;
			UnixSocket sock = ssock.accept() ;
			String request = Test.readLine(sock) ;
			System.err.println("server: got request: " + request) ;
			sock.write(Integer.toString(request.hashCode()).getBytes()) ;
			sock.write('\n') ;
			sock.close() ;
			ssock.close() ;
		}
		catch (IOException e) {
			throw new RuntimeException(e) ;
		}
	}
	
}
