import java.io.IOException ;
import java.io.File ;

public class UnixServerSocket {
	
	static {
		System.loadLibrary("unixsocket") ;
	}
	
	private String addr ;
	private int sock ;
	
	public UnixServerSocket(String addr, int backlog) throws IOException {
		this.addr = addr ;
		this.sock = open(addr, backlog) ;
	}
	
	public UnixServerSocket(String addr) throws IOException {
		this(addr, 50) ;
	}
	
	private static int open(String addr, int backlog) throws UnixSocketException {
		return JNIUtils.decode(_open(addr, backlog)) ;
	}
	
	private static native long _open(String addr, int backlog) ;
	
	public String getAddress() {
		return addr ;
	}
	
	public UnixSocket accept() throws IOException {
		int asock = JNIUtils.decode(_accept(sock)) ;
		return new UnixSocket(addr, asock) ;
	}
	
	private static native long _accept(int sock) ;
	
	public void close() throws IOException {
		try {
			JNIUtils.decode(_close(sock)) ;
		}
		finally {
			new File(addr).delete() ;
		}
	}
	
	private static native long _close(int sock) ;
	
	protected void finalize() throws IOException {
		close() ;
	}
	
}
