import java.io.IOException ;

public class UnixSocketException extends IOException {
	
	public static final String[] FUNCTIONS = {
		null,
		"socket",
		"bind",
		"listen",
		"connect",
		"accept",
		"close",
		"ReleaseByteArrayElements",
		"recv",
		"send"
	} ;
	
	private static String lookup(String[] arr, int i) {
		String s ;
		s = arr[i] ;
		if (s == null) s = "(unspecified)" ;
		return s ;
	}
	
	private int function ;
	private int error ;
	
	public UnixSocketException(int function, int error) {
		if (function < 0) throw new IllegalArgumentException("illegal function number: " + function) ;
		if (error < 0) throw new IllegalArgumentException("illegal error number: " + error) ;
		this.function = function ;
		this.error = error ;
	}
	
	public String getFunctionName() {
		return lookup(FUNCTIONS, function) ;
	}
	
	public String getErrorName() {
		return lookup(Errno.NAMES, error) ;
	}
	
	public String toString() {
		return "UnixSocketException: " + getFunctionName() + " " + getErrorName() ;
	}
	
}
